/****************************************************************
**                                                             **
**             Copyright (c) 1996 AIM Technology               **
**                     All Rights Reserved                     **
**                                                             **
**   AIM Technology retains the ownership of this copy of      **
**   software.  Use, duplication, or sale of this product,     **
**   except as described in the AIM License Agreement is       **
**   strictly prohibited.  This license and your right to      **
**   use the software automatically terminate if you fail      **
**   to comply with any provision of the License Agreement.    **
**   Violators may be prosecuted.                              **
**                                                             **
****************************************************************/
#define _POSIX_SOURCE 1

#include <stdio.h>						 /* enable scanf(), etc. */
#include <stdlib.h>						 /* enable exit(), etc. */
#include <string.h>
#include "suite.h"

static int ram_copy();

source_file *ram_c()
{
  static source_file s = {" @(#) ram.c:1.4 7/26/93 16:48:37",			 /* SCCS info */
			    __FILE__, __DATE__,  __TIME__ };
  register_test("ram_copy",	"64", ram_copy, 25020, "Memory to Memory Copy");
  return &s;
}

static int 
  sizes[] = {							 /* determines how much to copy */
      1,   2,    3,    4,    5,    6, 
      7,   7,    7,    7,    7,    7,
      8,   9,   11,   17,   33,   63,
      7,   7,    7,    7,    7,    7, 
      1,   2,    3,    4,    5,    6,
      7,   7,    7,    7,    7,    7, 
    127, 256, 1001, 1200, 1492, 1500,
   1024,2048, 3172, 4096, 8192,  512,
      7,   7,    7,    7,    7,    7,
      1,   2,    3,    4,    5,    6,
      7,   7,    7,    7,    7,    7, 
      8,   9,   11,   17,   33,   63,
      7,   7,    7,    7,    7,    7, 
      1,   2,    3,    4,    5,    6,
      7,   7,    7,    7,    7,    7, };

static char 
    a[8192+sizeof(double)],					 /* source */
    b[8192+sizeof(double)];					 /* destination */
    /* +sizeof(double) because we will be writing 8192 bytes to offset sizeof(double) at some time */

/* Copy data to and from ram at different offsets.  Assume memory alignments between 0 and sizeof(double) */
static int ram_copy(char *argv, Result *res)
{
  int n, i64;
  
  if ( sscanf(argv, "%d", &i64) < 1 ) {
    fprintf(stderr, "ram_copy(): needs 1 argument!\n");
    return(-1);
  }
                     
  for (n = 0; n < i64; n++) {
    void 							 /* vary offsets with each call */
      *src= (void *)&b[n%sizeof(double)],			 /* try all src & dest double word offsets */
      *dst = (void *)&a[(n/sizeof(double))%sizeof(double)];	 /* insure offset always from 0 to sizeof(double) */
    int 
      count = sizes[n % Members(sizes)];			 /* vary copy sizes by table above */
    memcpy(src,dst,count);					 /* memcpy() can never fail */
  } 
  res->c = b[i64];
  return(0);
}
