/****************************************************************
**                                                             **
**             Copyright (c) 1996 AIM Technology               **
**                     All Rights Reserved                     **
**                                                             **
**   AIM Technology retains the ownership of this copy of      **
**   software.  Use, duplication, or sale of this product,     **
**   except as described in the AIM License Agreement is       **
**   strictly prohibited.  This license and your right to      **
**   use the software automatically terminate if you fail      **
**   to comply with any provision of the License Agreement.    **
**   Violators may be prosecuted.                              **
**                                                             **
****************************************************************/
#define _POSIX_SOURCE 1						 /* enable POSIX functions */

#include <sys/types.h>
#include <sys/times.h>
#include <time.h>
#include <stdio.h>						 /* enable printf(), etc. */
#include <stdlib.h>
#include <unistd.h>						 /* enable sysconf(), etc. */
#include "suite.h"
#include "testerr.h"

static double rate; 
source_file *rtmsec_c()
{
  static source_file s = {" @(#) rtmsec.c:1.4 3/4/94 17:26:40",		  /* SCCS info */
			    __FILE__, __DATE__,  __TIME__ };
  long	hertz;											  /* HZ */

  hertz = sysconf(_SC_CLK_TCK);
  if (hertz == -1) {
    fprintf(stderr, "Cannot get HZ\n");
    exit(1);
  }

  rate = 1000.0 / (double) hertz;

  return &s;
}

/*
 * long rmtsec(int)
 *
 * Description
 *	Returns real time in milliseconds.
 *
 * Arguments
 *	TRUE (1) - resets its internal 'epoch' marker
 *	FALSE(0) - returns time since last reset
 *
 * Modification
 *	6/12/89 Added documentation, minor fixes; Tin Le
 */
long rtmsec(int reset)
{
  /* 
   * rtmsec - the timing routines used by multitask 
   */
  struct tms	ts;
  static clock_t	epoch=0l;
  clock_t		delta, retval;
  double temp;
  /*
   *  Milliseconds returned are now since first call.
   */
  delta = times(&ts);                                        /* get the time *NOW* */
  if ((epoch == 0l)||(reset == TRUE)) {
    epoch = delta;
    retval = 0;
  }
  else {	
    temp = rate * ((double)delta - (double)epoch);
    retval = (long) temp;
  }
  return retval;
}
